diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-emlsr-test-base.h ns-3.45/src/wifi/test/wifi-emlsr-test-base.h
--- ns-3.44/src/wifi/test/wifi-emlsr-test-base.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.45/src/wifi/test/wifi-emlsr-test-base.h	2025-06-01 20:34:45.636702300 -0700
@@ -0,0 +1,272 @@
+/*
+ * Copyright (c) 2023 Universita' degli Studi di Napoli Federico II
+ *
+ * SPDX-License-Identifier: GPL-2.0-only
+ *
+ * Author: Stefano Avallone <stavallo@unina.it>
+ */
+
+#ifndef WIFI_EMLSR_TEST_H
+#define WIFI_EMLSR_TEST_H
+
+#include "ns3/adhoc-wifi-mac.h"
+#include "ns3/ap-wifi-mac.h"
+#include "ns3/error-model.h"
+#include "ns3/header-serialization-test.h"
+#include "ns3/packet-socket-address.h"
+#include "ns3/packet-socket-client.h"
+#include "ns3/sta-wifi-mac.h"
+#include "ns3/test.h"
+#include "ns3/wifi-mac-queue-scheduler.h"
+#include "ns3/wifi-mac.h"
+#include "ns3/wifi-ppdu.h"
+#include "ns3/wifi-psdu.h"
+
+#include <array>
+#include <map>
+#include <memory>
+#include <optional>
+#include <set>
+#include <vector>
+
+using namespace ns3;
+using namespace std::string_literals;
+
+// forward declaration
+namespace ns3
+{
+struct EmlsrMainPhySwitchTrace;
+}
+
+/**
+ * @ingroup wifi-test
+ * @ingroup tests
+ *
+ * @brief Base class for EMLSR Operations tests
+ *
+ * This base class setups and configures one AP MLD, a variable number of non-AP MLDs with
+ * EMLSR activated and a variable number of non-AP MLD with EMLSR deactivated. Every MLD has
+ * three links, each operating on a distinct PHY band (2.4 GHz, 5 GHz and 6 GHz). Therefore,
+ * it is expected that three links are setup by the non-AP MLD(s). The values for the Padding
+ * Delay, the Transition Delay and the Transition Timeout are provided as argument to the
+ * constructor of this class, along with the IDs of the links on which EMLSR mode must be
+ * enabled for the non-AP MLDs (this information is used to set the EmlsrLinkSet attribute
+ * of the DefaultEmlsrManager installed on the non-AP MLDs).
+ */
+class EmlsrOperationsTestBase : public TestCase
+{
+  public:
+    /**
+     * Constructor
+     *
+     * @param name The name of the new TestCase created
+     */
+    EmlsrOperationsTestBase(const std::string& name);
+    ~EmlsrOperationsTestBase() override = default;
+
+    /// Enumeration for traffic directions
+    enum TrafficDirection : uint8_t
+    {
+        DOWNLINK = 0,
+        UPLINK
+    };
+
+  protected:
+    /**
+     * Callback invoked when a FEM passes PSDUs to the PHY.
+     *
+     * @param mac the MAC transmitting the PSDUs
+     * @param phyId the ID of the PHY transmitting the PSDUs
+     * @param psduMap the PSDU map
+     * @param txVector the TX vector
+     * @param txPowerW the tx power in Watts
+     */
+    virtual void Transmit(Ptr<WifiMac> mac,
+                          uint8_t phyId,
+                          WifiConstPsduMap psduMap,
+                          WifiTxVector txVector,
+                          double txPowerW);
+
+    /**
+     * @param dir the traffic direction (downlink/uplink)
+     * @param staId the index (starting at 0) of the non-AP MLD generating/receiving packets
+     * @param count the number of packets to generate
+     * @param pktSize the size of the packets to generate
+     * @param priority user priority for generated packets
+     * @return an application generating the given number packets of the given size from/to the
+     *         AP MLD to/from the given non-AP MLD
+     */
+    Ptr<PacketSocketClient> GetApplication(TrafficDirection dir,
+                                           std::size_t staId,
+                                           std::size_t count,
+                                           std::size_t pktSize,
+                                           uint8_t priority = 0) const;
+
+    /**
+     * Check whether QoS data unicast transmissions addressed to the given destination on the
+     * given link are blocked or unblocked for the given reason on the given device.
+     *
+     * @param mac the MAC of the given device
+     * @param dest the MAC address of the given destination
+     * @param linkId the ID of the given link
+     * @param reason the reason for blocking transmissions to test
+     * @param blocked whether transmissions are blocked for the given reason
+     * @param description text indicating when this check is performed
+     * @param testUnblockedForOtherReasons whether to test if transmissions are unblocked for
+     *                                     all the reasons other than the one provided
+     */
+    void CheckBlockedLink(Ptr<WifiMac> mac,
+                          Mac48Address dest,
+                          uint8_t linkId,
+                          WifiQueueBlockedReason reason,
+                          bool blocked,
+                          std::string description,
+                          bool testUnblockedForOtherReasons = true);
+
+    /**
+     * Check whether the MediumSyncDelay timer is running on the given link of the given device.
+     *
+     * @param staMac the MAC of the given device
+     * @param linkId the ID of the given link
+     * @param isRunning whether the MediumSyncDelay timer is running
+     * @param msg message to print in case the check failed
+     */
+    void CheckMsdTimerRunning(Ptr<StaWifiMac> staMac,
+                              uint8_t linkId,
+                              bool isRunning,
+                              const std::string& msg);
+
+    /**
+     * Check whether aux PHYs of the given device are in sleep mode/awake.
+     *
+     * @param staMac the MAC of the given device
+     * @param sleep whether aux PHYs should be in sleep mode
+     */
+    void CheckAuxPhysSleepMode(Ptr<StaWifiMac> staMac, bool sleep);
+
+    /**
+     * Callback connected to the EMLSR Manager MainPhySwitch trace source.
+     *
+     * @param index the index of the EMLSR client whose main PHY switch event is logged
+     * @param info the information associated with the main PHY switch event
+     */
+    virtual void MainPhySwitchInfoCallback(std::size_t index, const EmlsrMainPhySwitchTrace& info);
+
+    /**
+     * Check information provided by the EMLSR Manager MainPhySwitch trace.
+     *
+     * @param index the ID of the EMLSR client this check refers to
+     * @param reason the reason for main PHY to switch
+     * @param fromLinkId the ID of the link the main PHY is moving from (if any)
+     * @param toLinkId the ID of the link the main PHY is moving to
+     * @param checkFromLinkId whether to check the given fromLinkId value
+     * @param checkToLinkId whether to check the given toLinkId value
+     */
+    void CheckMainPhyTraceInfo(std::size_t index,
+                               std::string_view reason,
+                               const std::optional<uint8_t>& fromLinkId,
+                               uint8_t toLinkId,
+                               bool checkFromLinkId = true,
+                               bool checkToLinkId = true);
+
+    void DoSetup() override;
+
+    /// Information about transmitted frames
+    struct FrameInfo
+    {
+        Time startTx;             ///< TX start time
+        WifiConstPsduMap psduMap; ///< transmitted PSDU map
+        WifiTxVector txVector;    ///< TXVECTOR
+        uint8_t linkId;           ///< link ID
+        uint8_t phyId;            ///< ID of the transmitting PHY
+    };
+
+    /// array of strings defining the channels for the MLD links
+    std::array<std::string, 3> m_channelsStr{"{2, 0, BAND_2_4GHZ, 0}"s,
+                                             "{36, 0, BAND_5GHZ, 0}"s,
+                                             "{1, 0, BAND_6GHZ, 0}"s};
+
+    /// array of frequency ranges for MLD links
+    const std::array<FrequencyRange, 3> m_freqRanges{WIFI_SPECTRUM_2_4_GHZ,
+                                                     WIFI_SPECTRUM_5_GHZ,
+                                                     WIFI_SPECTRUM_6_GHZ};
+
+    uint32_t m_rngSeed{1};                    //!< RNG seed value
+    uint64_t m_rngRun{1};                     //!< RNG run value
+    int64_t m_streamNo{5};                    //!< RNG stream number
+    uint8_t m_mainPhyId{0};                   //!< ID of the main PHY
+    std::set<uint8_t> m_linksToEnableEmlsrOn; /**< IDs of the links on which EMLSR mode has to
+                                                   be enabled */
+    std::size_t m_nPhysPerEmlsrDevice{3};     //!< number of PHYs per EMLSR client
+    std::size_t m_nEmlsrStations{1};          ///< number of stations to create that activate EMLSR
+    std::size_t m_nNonEmlsrStations{0};       /**< number of stations to create that do not
+                                                activate EMLSR */
+    Time m_transitionTimeout{MicroSeconds(128)}; ///< Transition Timeout advertised by the AP MLD
+    std::vector<Time> m_paddingDelay{
+        {MicroSeconds(32)}}; ///< Padding Delay advertised by the non-AP MLD
+    std::vector<Time> m_transitionDelay{
+        {MicroSeconds(16)}};                ///< Transition Delay advertised by the non-AP MLD
+    std::vector<uint8_t> m_establishBaDl{}; /**< the TIDs for which BA needs to be established
+                                                 with the AP as originator */
+    std::vector<uint8_t> m_establishBaUl{}; /**< the TIDs for which BA needs to be established
+                                                 with the AP as recipient */
+    bool m_putAuxPhyToSleep{false};   //!< whether aux PHYs are put to sleep during DL/UL TXOPs
+    std::vector<FrameInfo> m_txPsdus; ///< transmitted PSDUs
+    Ptr<ApWifiMac> m_apMac;           ///< AP wifi MAC
+    std::vector<Ptr<StaWifiMac>> m_staMacs;       ///< MACs of the non-AP MLDs
+    std::vector<PacketSocketAddress> m_dlSockets; ///< packet socket address for DL traffic
+    std::vector<PacketSocketAddress> m_ulSockets; ///< packet socket address for UL traffic
+    uint16_t m_startAid{1};                       ///< first AID to allocate to stations
+    uint16_t m_lastAid{0};                        ///< AID of last associated station
+    Time m_duration{0};                           ///< simulation duration
+    std::map<std::size_t, std::shared_ptr<EmlsrMainPhySwitchTrace>>
+        m_traceInfo; ///< EMLSR client ID-indexed map of trace info from last main PHY switch
+
+  private:
+    /**
+     * Callback connected to the ApWifiMac's AssociatedSta trace source.
+     * Start generating traffic (if needed) when all stations are associated.
+     *
+     * @param aid the AID assigned to the previous associated STA
+     */
+    void StaAssociated(uint16_t aid, Mac48Address /* addr */);
+
+    /**
+     * Callback connected to the QosTxop's BaEstablished trace source of the AP's BE AC.
+     *
+     * @param recipient the recipient of the established Block Ack agreement
+     * @param tid the TID
+     */
+    void BaEstablishedDl(Mac48Address recipient,
+                         uint8_t tid,
+                         std::optional<Mac48Address> /* gcrGroup */);
+
+    /**
+     * Callback connected to the QosTxop's BaEstablished trace source of a STA's BE AC.
+     *
+     * @param index the index of the STA which the callback is connected to
+     * @param recipient the recipient of the established Block Ack agreement
+     * @param tid the TID
+     */
+    void BaEstablishedUl(std::size_t index,
+                         Mac48Address recipient,
+                         uint8_t tid,
+                         std::optional<Mac48Address> /* gcrGroup */);
+
+    /**
+     * Set the SSID on the next station that needs to start the association procedure, or start
+     * traffic if no other station left.
+     *
+     * @param count the number of STAs that completed the association procedure
+     */
+    void SetSsid(std::size_t count);
+
+    /**
+     * Start the generation of traffic (needs to be overridden)
+     */
+    virtual void StartTraffic()
+    {
+    }
+};
+
+#endif /* WIFI_EMLSR_TEST_H */
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-fils-frame-test.cc ns-3.45/src/wifi/test/wifi-fils-frame-test.cc
--- ns-3.44/src/wifi/test/wifi-fils-frame-test.cc	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/test/wifi-fils-frame-test.cc	2025-06-01 20:34:45.637702200 -0700
@@ -70,11 +70,13 @@
 static const auto DEFAULT_ENABLE_PCAP = false;
 static const auto DEFAULT_AP_LOC = Vector(0.01, 0, 0);
 static const auto DEFAULT_CLIENT_LOC = Vector(0, 0, 0);
-static const uint8_t WIFI_6GHZ_FD_PHY_IDX = 4;
+static const uint8_t WIFI_11AX_FD_PHY_IDX = 4;
+static const uint8_t WIFI_11BE_FD_PHY_IDX = 5;
 
 /// @brief  Wi-Fi FILS frame test parameters
 struct WifiFilsFrameTestParams
 {
+    WifiStandard standard{DEFAULT_STANDARD};            ///< Standard
     MHz_u bw{DEFAULT_BANDWIDTH};                        ///< Operation bandwidth
     std::string ssid{DEFAULT_SSID};                     ///< SSID name
     uint8_t nss{0};                                     ///< Number of spatial streams
@@ -186,7 +188,7 @@
     phy.Set("MaxSupportedTxSpatialStreams", UintegerValue(m_params.nss));
     phy.Set("MaxSupportedRxSpatialStreams", UintegerValue(m_params.nss));
 
-    wifi.SetStandard(DEFAULT_STANDARD);
+    wifi.SetStandard(m_params.standard);
     wifi.SetRemoteStationManager("ns3::ConstantRateWifiManager");
 
     if (isAp)
@@ -341,7 +343,9 @@
                           +m_params.expNssFld,
                           "FILS Discovery frame NSS mismatch");
     NS_TEST_ASSERT_MSG_EQ(+filsDisc.m_fdCap->m_phyIdx,
-                          +WIFI_6GHZ_FD_PHY_IDX,
+                          ((m_params.standard == WifiStandard::WIFI_STANDARD_80211be)
+                               ? +WIFI_11BE_FD_PHY_IDX
+                               : +WIFI_11AX_FD_PHY_IDX),
                           "FILS Discovery frame PHY idx mismatch");
 }
 
@@ -373,6 +377,7 @@
     BW80MHZ_NSS2_DISC,
     BW160MHZ_NSS2_DISC,
     BW160MHZ_NSS2_PROBE,
+    BW320MHZ_NSS3_DISC,
     COUNT,
 };
 
@@ -429,6 +434,15 @@
         params.expChWidFld = 3;
         params.expNssFld = 1;
         break;
+    case WifiFilsFrameTestCase::BW320MHZ_NSS3_DISC:
+        params.standard = WifiStandard::WIFI_STANDARD_80211be;
+        params.bw = MHz_u{320};
+        params.ssid = "BW320MHZ_NSS3";
+        params.nss = 3;
+        params.filsIntrvl = 20 * WIFI_TU;
+        params.expChWidFld = 4;
+        params.expNssFld = 2;
+        break;
     default:
         NS_ABORT_MSG("Testcase is unsupported");
         break;
@@ -455,6 +469,7 @@
         {WifiFilsFrameTestBuildCase(WifiFilsFrameTestCase::BW80MHZ_NSS2_DISC)},
         {WifiFilsFrameTestBuildCase(WifiFilsFrameTestCase::BW160MHZ_NSS2_DISC)},
         {WifiFilsFrameTestBuildCase(WifiFilsFrameTestCase::BW160MHZ_NSS2_PROBE)},
+        {WifiFilsFrameTestBuildCase(WifiFilsFrameTestCase::BW320MHZ_NSS3_DISC)},
     };
     for (const auto& tc : testCases)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-gcr-test.cc ns-3.45/src/wifi/test/wifi-gcr-test.cc
--- ns-3.44/src/wifi/test/wifi-gcr-test.cc	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/test/wifi-gcr-test.cc	2025-06-01 20:34:45.637702200 -0700
@@ -744,9 +744,9 @@
     // WifiHelper::EnableLogComponents();
     // LogComponentEnable("WifiGcrTest", LOG_LEVEL_ALL);
 
-    RngSeedManager::SetSeed(1);
-    RngSeedManager::SetRun(2);
-    int64_t streamNumber = 100;
+    RngSeedManager::SetSeed(m_rngSeed);
+    RngSeedManager::SetRun(m_rngRun);
+    int64_t streamNumber = m_streamNo;
 
     Config::SetDefault("ns3::WifiMacQueue::MaxDelay", TimeValue(m_params.maxLifetime));
     const auto maxPacketsInQueue = std::max<uint16_t>(m_params.numGroupcastPackets + 1, 500);
@@ -908,17 +908,12 @@
         if (m_params.stas.at(i).standard >= WIFI_STANDARD_80211n)
         {
             auto staHtConfiguration = CreateObject<HtConfiguration>();
-            staHtConfiguration->m_40MHzSupported =
-                (m_params.stas.at(i).standard >= WIFI_STANDARD_80211ac ||
-                 m_params.stas.at(i).maxChannelWidth >= MHz_u{40});
             staHtConfiguration->m_sgiSupported = (m_params.stas.at(i).minGi == NanoSeconds(400));
             staNetDevice->SetHtConfiguration(staHtConfiguration);
         }
         if (m_params.stas.at(i).standard >= WIFI_STANDARD_80211ac)
         {
             auto staVhtConfiguration = CreateObject<VhtConfiguration>();
-            staVhtConfiguration->m_160MHzSupported =
-                (m_params.stas.at(i).maxChannelWidth >= MHz_u{160});
             staNetDevice->SetVhtConfiguration(staVhtConfiguration);
         }
         if (m_params.stas.at(i).standard >= WIFI_STANDARD_80211ax)
@@ -1046,6 +1041,7 @@
       m_gcrUrParams{gcrUrParams},
       m_currentUid{0}
 {
+    m_rngRun = 2;
 }
 
 void
@@ -1373,6 +1369,7 @@
       m_lastTxSeq{-1},
       m_nTxGcrBarsInCurrentTxop{0}
 {
+    m_rngRun = 5;
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.44/src/wifi/test/wifi-gcr-test.h ns-3.45/src/wifi/test/wifi-gcr-test.h
--- ns-3.44/src/wifi/test/wifi-gcr-test.h	2025-03-09 16:55:49.807372600 -0700
+++ ns-3.45/src/wifi/test/wifi-gcr-test.h	2025-06-01 20:34:45.637702200 -0700
@@ -192,9 +192,12 @@
      */
     virtual bool IsUsingAmpduOrSmpdu() const;
 
-    std::string m_testName; ///< name of the test
-    GcrParameters m_params; ///< parameters for the test to run
-    bool m_expectGcrUsed;   ///< flag whether GCR is expected to be used during the test
+    std::string m_testName;  ///< name of the test
+    uint32_t m_rngSeed{1};   ///< RNG seed value
+    uint64_t m_rngRun{1};    ///< RNG run value
+    int64_t m_streamNo{100}; ///< RNG stream number
+    GcrParameters m_params;  ///< parameters for the test to run
+    bool m_expectGcrUsed;    ///< flag whether GCR is expected to be used during the test
     uint16_t m_expectedMaxNumMpdusInPsdu; ///< expected maximum number of MPDUs in PSDUs
 
     Ptr<ApWifiMac> m_apWifiMac;                 ///< AP wifi MAC
